#include "VisualizationEllipsoid.h"

#include <Inventor/nodes/SoComplexity.h>
#include <Inventor/nodes/SoScale.h>
#include <Inventor/nodes/SoSphere.h>

armarx::viz::coin::VisualizationEllipsoid::VisualizationEllipsoid()
{
    complexity = new SoComplexity();
    complexity->type.setValue(SoComplexity::OBJECT_SPACE);
    complexity->value.setValue(1.0f);

    scale = new SoScale;

    sphere = new SoSphere();
    // We create a unit sphere and create an ellipsoid through scaling
    sphere->radius.setValue(1.0f);

    node->addChild(complexity);
    node->addChild(scale);
    node->addChild(sphere);
}

bool
armarx::viz::coin::VisualizationEllipsoid::update(ElementType const& element)
{
    scale->scaleFactor.setValue(
        element.axisLengths.e0, element.axisLengths.e1, element.axisLengths.e2);

    return true;
}
