#pragma once

#include <RobotAPI/interface/ArViz/Elements.h>

#include "ElementVisualizer.h"
#include <Inventor/SbColor.h>

class SoCoordinate3;
class SoIndexedFaceSet;

namespace armarx::viz::coin
{
    struct VisualizationMesh : TypedElementVisualization<SoSeparator>
    {
        using ElementType = data::ElementMesh;

        VisualizationMesh();

        bool update(ElementType const& element);

        SoMaterial* materials;
        SoCoordinate3* coords;
        SoIndexedFaceSet* faceSet;

        std::vector<SbColor> matColor;
        std::vector<float> transp;
        std::vector<SbVec3f> vertexPositions;
        std::vector<int32_t> faces;
        std::vector<int32_t> matInx;
    };
} // namespace armarx::viz::coin
