#pragma once

#include <ArmarXCore/core/Component.h>

#include <RobotAPI/components/units/ForceTorqueUnit.h>
#include <RobotAPI/components/units/RobotUnit/SensorValues/SensorValueBattery.h>
#include <RobotAPI/components/units/RobotUnit/Units/RobotUnitSubUnit.h>
#include <RobotAPI/interface/units/DiagnosticsUnitInterface.h>
#include <RobotAPI/interface/units/LocalizationUnitInterface.h>

namespace armarx
{

    class DiagnosticsSubUnit :
        virtual public RobotUnitSubUnit,
        virtual public armarx::DiagnosticsUnitInterface,
        virtual public Component
    {
    public:
        dto::BatteryStatus getBatteryStatus(const Ice::Current& current) const override;

        std::string getDefaultName() const override;

        void update(const SensorAndControl& sc, const JointAndNJointControllers& c) override;

        void
        setBatteryManagementDevices(std::map<std::string, std::size_t> batteryManagementDevices);

    protected:
        void onInitComponent() override;
        void onConnectComponent() override;

        std::map<std::string, std::size_t> _batteryManagementDevices;

        std::map<std::string, dto::BatteryStatus> _lastBatteryStatuses;

        /*
        // UnitResourceManagementInterface interface
    public:
        void request(const Ice::Current &current);
        void release(const Ice::Current &current);

        // UnitExecutionManagementInterface interface
    public:
        void init(const Ice::Current &current);
        void start(const Ice::Current &current);
        void stop(const Ice::Current &current);
        UnitExecutionState getExecutionState(const Ice::Current &current);*/
    };

} // namespace armarx
