#include "CustomWidget.h"

#include "ArmarXCore/core/exceptions/local/ExpressionException.h"

namespace armarx
{
    CustomWidget::CustomWidget(QTreeWidgetItem* overlayingItem) : overlayingItem(overlayingItem)
    {
        // connect to general QTreeWidgetItem callback.
        // This also lets the conversion start for other objects. (Not just this widget)
        ARMARX_CHECK(connect(this,
                             SIGNAL(elemChanged(QTreeWidgetItem*, int)),
                             overlayingItem->treeWidget(),
                             SIGNAL(itemChanged(QTreeWidgetItem*, int))));
    }

    CustomWidget*
    CustomWidget::DynamicCast(QWidget* elem)
    {
        return dynamic_cast<CustomWidget*>(elem);
    }

    CustomWidget*
    CustomWidget::DynamicCastAndCheck(QWidget* elem)
    {
        if (!elem)
        {
            return nullptr;
        }
        auto* casted = DynamicCast(elem);
        ARMARX_CHECK_NOT_NULL(casted);
        return casted;
    }

    void
    CustomWidget::setSupressSignals(bool doSupress)
    {
        QObject::blockSignals(doSupress);
    }


} // namespace armarx
