/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * package    SpeechX::aron_cpp_to_python_conv_test
 * author     Rainer Kartmann ( rainer dot kartmann at kit dot edu )
 * date       2023
 * copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *            GNU General Public License
 */


#pragma once

#include <RobotAPI/interface/aron/Aron.ice>


module armarx
{
    module aron
    {
        module test
        {

            module dto
            {

                struct TestAronConversionRequest
                {
                    string aronClassName;
                    ::armarx::aron::data::dto::Dict probe;
                };

                struct TestAronConversionResponse
                {
                    bool success;
                    string errorMessage;

                    ::armarx::aron::data::dto::Dict probe;
                };
            };


            module dti
            {

                interface AronConversionTestInterface
                {
                    dto::TestAronConversionResponse testAronConversion(
                        dto::TestAronConversionRequest req);
                };
            };
        };
    };
};
