#pragma once

// Base Class
#include "../../../../extractor/imageExtractor/DepthImageExtractor.h"
#include "../Converter.h"

namespace armarx::armem::server::ltm::processor::converter::data::image
{
    class ExrConverter : public ImageConverter
    {
    public:
        static const constexpr char* NAME = "ExrConverter";

        ExrConverter() :
            ImageConverter(ConverterType::Binary,
                           "depthimage",
                           ".exr",
                           std::make_unique<extractor::DepthImageExtractor>())
        {
        }

    protected:
        ConversionResult _convert(const aron::data::NDArrayPtr& data) final;
        aron::data::NDArrayPtr _convert(const ConversionResult& data,
                                        const armarx::aron::Path& p) final;
    };
} // namespace armarx::armem::server::ltm::processor::converter::data::image
