#pragma once

#include <QString>
#include <QWidget>

// Qt headers must come before <filesystem>
// https://stackoverflow.com/questions/69407237/qt-moc-errorusr-include-c-10-bits-fs-fwd-39-parse-error-at-std
#include <filesystem>

#include <RobotAPI/libraries/armem/client/Query.h>
#include <RobotAPI/libraries/armem/core/forward_declarations.h>


class QPushButton;

namespace armarx::armem::gui::disk
{

    class ControlWidget : public QWidget
    {
        Q_OBJECT
        using This = ControlWidget;

    public:
        ControlWidget();


        void storeOnDisk(QString directory,
                         const std::vector<wm::Memory> memoryData,
                         std::string* outStatus = nullptr);

        std::map<std::filesystem::path, wm::Memory>
        loadFromDisk(QString directory,
                     const armem::client::QueryInput& queryInput,
                     std::string* outStatus = nullptr);


    signals:

        void requestedLoadFromDisk(QString directory);
        void requestedStoreOnDisk(QString directory);


    private slots:

        QString chooseDirectoryDialog();


    signals:


    private:
        QPushButton* _loadFromDiskButton;
        QPushButton* _storeOnDiskButton;

        QString _latestDirectory;
    };

} // namespace armarx::armem::gui::disk
