#pragma once


#include "RobotAPI/libraries/armem/core/forward_declarations.h"
#include <RobotAPI/libraries/armem/core/Time.h>
#include <RobotAPI/libraries/armem_robot_state/types.h>

namespace armarx::armem::robot_state
{

    class WriterInterface
    {
    public:
        virtual ~WriterInterface() = default;

        // virtual bool store(const Robot& obj) = 0;

        virtual bool storeDescription(const description::RobotDescription& description,
                                      const armem::Time& timestamp = armem::Time::Invalid()) = 0;

        virtual bool storeState(const RobotState& state,
                                const std::string& robotTypeName,
                                const std::string& robotName,
                                const std::string& robotRootNodeName) = 0;
    };

} // namespace armarx::armem::robot_state
