/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    RobotAPI::ArmarXObjects::armem_robot_state
 * @author     Rainer Kartmann ( rainer dot kartmann at kit dot edu )
 * @date       2022
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#include "memory_ids.h"

namespace armarx::armem::robot_state // ::constants
{

    const MemoryID memoryID{"RobotState"};

    const MemoryID descriptionSegmentID{memoryID.withCoreSegmentName("Description")};
    const MemoryID proprioceptionSegmentID{memoryID.withCoreSegmentName("Proprioception")};
    const MemoryID exteroceptionSegmentID{memoryID.withCoreSegmentName("Exteroception")};
    const MemoryID localizationSegmentID{memoryID.withCoreSegmentName("Localization")};


} // namespace armarx::armem::robot_state
