#pragma once

#include <ArmarXCore/interface/core/Profiler.h>
#include <ArmarXCore/observers/ObserverObjectFactories.h>

#include <RobotAPI/libraries/armem_skills/aron/Skill.aron.generated.h>
#include <RobotAPI/libraries/armem_skills/aron/Statechart.aron.generated.h>
#include <RobotAPI/libraries/skills/core/SkillDescription.h>
#include <RobotAPI/libraries/skills/core/SkillExecutionRequest.h>
#include <RobotAPI/libraries/skills/core/SkillStatusUpdate.h>

namespace armarx::armem
{
    void fromAron(const armarx::skills::arondto::Statechart::StateType& dto,
                  armarx::eStateType& bo);
    void toAron(armarx::skills::arondto::Statechart::StateType& dto, const armarx::eStateType& bo);

    void fromAron(const armarx::skills::arondto::Statechart::ParameterMap& dto,
                  armarx::StateParameterMap& bo);
    void toAron(armarx::skills::arondto::Statechart::ParameterMap& dto,
                const armarx::StateParameterMap& bo);

    void fromAron(const armarx::skills::arondto::Statechart::Transition& dto,
                  armarx::ProfilerStatechartTransitionWithParameters& bo);
    void toAron(armarx::skills::arondto::Statechart::Transition& dto,
                const armarx::ProfilerStatechartTransitionWithParameters& bo);

    void fromAron(const armarx::skills::arondto::ProviderID& dto, skills::ProviderID& bo);
    void toAron(armarx::skills::arondto::ProviderID& dto, const skills::ProviderID& bo);

    void fromAron(const armarx::skills::arondto::SkillID& dto, skills::SkillID& bo);
    void toAron(armarx::skills::arondto::SkillID& dto, const skills::SkillID& bo);

    void fromAron(const armarx::skills::arondto::SkillDescription& dto,
                  skills::SkillDescription& bo);
    void toAron(armarx::skills::arondto::SkillDescription& dto, const skills::SkillDescription& bo);

    void fromAron(const armarx::skills::arondto::SkillExecutionRequest& dto,
                  skills::SkillExecutionRequest& bo);
    void toAron(armarx::skills::arondto::SkillExecutionRequest& dto,
                const skills::SkillExecutionRequest& bo);

    void fromAron(const armarx::skills::arondto::SkillStatusUpdate& dto,
                  skills::SkillStatusUpdate& bo);
    void toAron(armarx::skills::arondto::SkillStatusUpdate& dto,
                const skills::SkillStatusUpdate& bo);
} // namespace armarx::armem
