#pragma once

#include <SimoxUtility/json/json.hpp>

#include <RobotAPI/libraries/aron/core/Path.h>
#include <RobotAPI/libraries/aron/core/data/variant/forward_declarations.h>
#include <RobotAPI/libraries/aron/core/type/variant/forward_declarations.h>

namespace armarx::aron::data::converter
{
    class AronNlohmannJSONConverter
    {
    public:
        AronNlohmannJSONConverter() = delete;

        static nlohmann::json ConvertToNlohmannJSON(const data::VariantPtr&);
        static void ConvertToNlohmannJSON(const data::VariantPtr&, nlohmann::json&);

        static data::DictPtr ConvertFromNlohmannJSONObject(const nlohmann::json&,
                                                           const armarx::aron::Path& p = {});
        static void ConvertFromNlohmannJSON(data::VariantPtr&,
                                            const nlohmann::json&,
                                            const aron::type::VariantPtr& = nullptr);
    };
} // namespace armarx::aron::data::converter

namespace armarx::aron::type::converter
{
    class AronNlohmannJSONConverter
    {
    public:
        AronNlohmannJSONConverter() = delete;

        static nlohmann::json ConvertToNlohmannJSON(const type::VariantPtr&);
        static void ConvertToNlohmannJSON(const type::VariantPtr&, nlohmann::json&);

        static type::ObjectPtr ConvertFromNlohmannJSONTypeObject(const nlohmann::json& j,
                                                                 const armarx::aron::Path& p = {});
        static void ConvertFromNlohmannJSON(aron::type::VariantPtr& a, const nlohmann::json& e);
    };
} // namespace armarx::aron::type::converter

// legacy
namespace armarx::aron::converter
{
    using AronNlohmannJSONConverter = ::armarx::aron::data::converter::AronNlohmannJSONConverter;
}
