#pragma once

#include <vector>

#include "RobotAPI/libraries/aron/core/data/variant/primitive/Float.h"

namespace armarx::aron::similarity::FloatSimilarity
{

    enum Type
    {
        MSE,
        MAE,
        NONE
    };

    double
    calculate_similarity(armarx::aron::data::FloatPtr f1, armarx::aron::data::FloatPtr f2, Type t);

    double calculate_similarity_multi(std::vector<armarx::aron::data::FloatPtr>& images,
                                      armarx::aron::data::FloatPtr p,
                                      Type type);

    double calculateMAE(armarx::aron::data::FloatPtr f1, armarx::aron::data::FloatPtr f2);

    double calculateMSE(armarx::aron::data::FloatPtr f1, armarx::aron::data::FloatPtr f2);

} // namespace armarx::aron::similarity::FloatSimilarity
