#pragma once


#include <RobotAPI/interface/skills/SkillManagerInterface.h>

namespace armarx
{
    namespace skills
    {
        class SkillID;

        class ProviderID
        {
        public:
            bool operator==(const ProviderID& other) const;
            bool operator!=(const ProviderID& other) const;
            bool operator<(const ProviderID& other) const;
            bool operator<=(const ProviderID& other) const;

            manager::dto::ProviderID toManagerIce() const;
            callback::dto::ProviderID toCallbackIce() const;

            static ProviderID FromIce(const manager::dto::ProviderID&);
            static ProviderID FromIce(const callback::dto::ProviderID&);

            std::string toString() const;

            std::string providerName;
        };

        std::ostream& operator<<(std::ostream& os, const ProviderID& id);
    } // namespace skills
} // namespace armarx
