#pragma once

#include <string>

#include <ArmarXCore/core/time/DateTime.h>

#include <RobotAPI/interface/skills/SkillProviderInterface.h>
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>
#include <RobotAPI/libraries/skills/core/SkillID.h>

namespace armarx
{
    namespace skills
    {
        struct SkillExecutionID
        {
            SkillID skillId;
            std::string executorName;
            armarx::core::time::DateTime executionStartedTime;

            static const constexpr char* UNKNOWN = "UNKNOWN";
            static const constexpr char* ENTER_SEPARATOR = "[";
            static const constexpr char* EXIT_SEPARATOR = "]";
            static const constexpr char* SEPARATOR = "@";

            bool operator==(const SkillExecutionID& other) const;

            bool operator<(const SkillExecutionID& other) const;

            bool operator<=(const SkillExecutionID& other) const;

            skills::manager::dto::SkillExecutionID toManagerIce() const;

            skills::provider::dto::SkillExecutionID toProviderIce() const;

            static SkillExecutionID FromIce(const skills::manager::dto::SkillExecutionID&);

            static SkillExecutionID FromIce(const skills::provider::dto::SkillExecutionID&,
                                            const std::optional<skills::ProviderID>& providerName);

            std::string toString() const;
        };

    } // namespace skills
} // namespace armarx
