#pragma once

#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/interface/skills/SkillProviderInterface.h>
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>
#include <RobotAPI/libraries/skills/core/ProviderID.h>
#include <RobotAPI/libraries/skills/core/SkillID.h>

namespace armarx
{
    namespace skills
    {
        class SkillExecutionRequest
        {
        public:
            manager::dto::SkillExecutionRequest toManagerIce() const;
            provider::dto::SkillExecutionRequest toProviderIce() const;

            static SkillExecutionRequest FromIce(const manager::dto::SkillExecutionRequest&);
            static SkillExecutionRequest
            FromIce(const provider::dto::SkillExecutionRequest&,
                    const std::optional<skills::ProviderID>& providerId = std::nullopt);


            skills::SkillID skillId;
            std::string executorName;
            armarx::aron::data::DictPtr parameters = nullptr;
            callback::dti::SkillProviderCallbackInterfacePrx callbackInterface = nullptr;
        };
    } // namespace skills
} // namespace armarx
