
#include "Exception.h"

armarx::skills::error::SkillException::SkillException(const std::string& prettymethod,
                                                      const std::string& reason) :
    LocalException(prettymethod + ": " + reason + ".")
{
}

armarx::skills::error::SkillNotFoundException::SkillNotFoundException(
    const std::string& prettymethod,
    const std::string& reason) :
    SkillException(prettymethod, reason)
{
}

armarx::skills::error::SkillAbortedException::SkillAbortedException(const std::string& prettymethod,
                                                                    const std::string& reason) :
    SkillException(prettymethod, reason)
{
}

armarx::skills::error::SkillFailedException::SkillFailedException(const std::string& prettymethod,
                                                                  const std::string& reason) :
    SkillException(prettymethod, reason)
{
}

armarx::skills::error::NotImplementedYetException::NotImplementedYetException(
    const std::string& prettymethod) :
    SkillException(prettymethod, "This method is not yet implemented!")
{
}
