#pragma once

#include <stack>

#include <QDialog>

#include <ArmarXCore/core/system/ImportExportComponent.h>

#include <ArmarXGui/libraries/ArmarXGuiBase/ArmarXComponentWidgetController.h>
#include <ArmarXGui/libraries/ArmarXGuiBase/ArmarXGuiPlugin.h>
#include <ArmarXGui/libraries/SimpleConfigDialog/SimpleConfigDialog.h>

#include "RobotAPI/libraries/skills_gui/dict/ui_AronTreeWidgetDictInputModal.h"

#include "../AronTreeWidgetModal.h"

namespace armarx::skills::gui
{
    class AronTreeWidgetDictInputModalController : public AronTreeWidgetModal
    {
    public:
        AronTreeWidgetDictInputModalController(const std::string& label,
                                               AronTreeWidgetItem* item,
                                               QTreeWidget* parent);

    private slots:

        void submit() final;
        void reset() final;

        void addEmptyElement();

    private:
        std::vector<AronTreeWidgetItem*> addedItems;
        Ui::AronTreeWidgetDictInputModalWidget widget;
    };
} // namespace armarx::skills::gui
