#pragma once
#include <string>
#include <vector>

#include <SimoxUtility/algorithm/string.h>

namespace armarx::skills::gui
{
    class NDArrayHelper
    {
    public:
        // Uses the simox utility to parse floatingpoint and fixed precision types
        // it then writes the result into a byte vector
        // an empty byte vector encodes a parsing error.
        template <typename T>
        std::vector<unsigned char> static toByteVector(const std::string& str)
        {
            try
            {
                auto val = simox::alg::to_<T>(str);
                std::vector<unsigned char> res(sizeof(val), 0);
                T* reinterpPtr = reinterpret_cast<T*>(res.data());
                T* laundered = std::launder(reinterpPtr);
                *laundered = val;
                return res;
            }
            catch (const simox::error::SimoxError& err)
            {
                return {};
            }
        }
    };
} // namespace armarx::skills::gui
