#ifndef MEMORYCOMMUNICATOR_H
#define MEMORYCOMMUNICATOR_H

#include <memory>

#include "SkillManagerWrapper.h"

namespace armarx::skills::gui
{
    /*
     * This is a convenience base class to prevent repeatedly putting the SkillManagerWrapper in
     * every widget.
     */
    class MemoryCommunicatorBase
    {
    protected:
        // We don't want to instantiate the base class
        MemoryCommunicatorBase(std::shared_ptr<SkillManagerWrapper> _memory) : memory(_memory)
        {
        }

        // The interface of the memory, used by the skill memory gui
        std::shared_ptr<SkillManagerWrapper> memory;
    };
} // namespace armarx::skills::gui

#endif // MEMORYCOMMUNICATOR_H
