#include "ProfileMenuWidget.h"

#include <QHBoxLayout>
#include <QLabel>
#include <QVBoxLayout>

namespace armarx::skills::gui
{

    QIcon
    getIcon(const std::string name)
    {
        QPixmap pix(QString::fromStdString(":icons/" + name));
        QIcon icon(pix);
        return icon;
    }

    void
    ProfileMenuWidget::setupUi()
    {
        setArgsFromClipboard = new QPushButton();
        copyArgsToClipboard = new QPushButton();
        resetArgsToProfile = new QPushButton();
        profileSelector = new QComboBox();

        // layouting
        QVBoxLayout* mainLayout = new QVBoxLayout();
        QHBoxLayout* topLayout = new QHBoxLayout();

        mainLayout->addLayout(topLayout);
        mainLayout->addWidget(profileSelector);

        topLayout->addWidget(setArgsFromClipboard);
        topLayout->addWidget(copyArgsToClipboard);
        // this is not good. We should probably use a QSpacerItem here...
        topLayout->addWidget(new QLabel());
        topLayout->addWidget(resetArgsToProfile);

        this->setLayout(mainLayout);

        // Text
        setArgsFromClipboard->setText(QString::fromStdString(SET_ARGS_BUTTON_TEXT));
        copyArgsToClipboard->setText(QString::fromStdString(COPY_ARGS_BUTTON_TEXT));
        copyArgsToClipboard->setIcon(getIcon("edit-copy-4.svg"));
        resetArgsToProfile->setText(QString::fromStdString(RESET_ARGS_BUTTON_TEXT));
        resetArgsToProfile->setIcon(getIcon("refresh-black.svg"));
        profileSelector->addItem(QString::fromStdString(DEFAULT_PROFILE_TEXT));
        profileSelector->setDisabled(true);
        profileSelector->setToolTip(QString::fromStdString(PROFILE_NOT_IMPLEMENTED));
    }


} // namespace armarx::skills::gui
