#ifndef PROFILEMENUWIDGET_H
#define PROFILEMENUWIDGET_H

#include <QComboBox>
#include <QPushButton>
#include <QWidget>

#include "../memory/MemoryCommunicatorBase.h"

namespace armarx::skills::gui
{
    class ProfileMenuWidget : public QWidget, public MemoryCommunicatorBase
    {
        Q_OBJECT
    public:
        static const constexpr char* SET_ARGS_BUTTON_TEXT = "Set Args from Clipboard";
        static const constexpr char* COPY_ARGS_BUTTON_TEXT = " Copy Args to Clipboard";
        static const constexpr char* RESET_ARGS_BUTTON_TEXT = " Reset Args to Profile";
        static const constexpr char* DEFAULT_PROFILE_TEXT = "<No Profile selected. Using root>";
        static const constexpr char* PROFILE_NOT_IMPLEMENTED =
            "Profiles other than the root profile are currently not supported.";

        // contents are public, as this class is just a convenience wrapper
        QPushButton* setArgsFromClipboard = nullptr;
        QPushButton* copyArgsToClipboard = nullptr;
        QPushButton* resetArgsToProfile = nullptr;
        QComboBox* profileSelector = nullptr;

        ProfileMenuWidget(std::shared_ptr<SkillManagerWrapper> _memory, QWidget* parent = nullptr) :
            QWidget(parent), MemoryCommunicatorBase(_memory)
        {
            setupUi();
        }

    private:
        void setupUi();
    };
} // namespace armarx::skills::gui

#endif // PROFILEMENUWIDGET_H
