/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    RobotAPI::ForceTorqueUtility::ForceTorqueUtilityRemoteStateOfferer
 * @author     Raphael Grimm ( raphael dot grimm at kit dot edu )
 * @date       2018
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#include "ForceTorqueUtilityRemoteStateOfferer.h"

using namespace armarx;
using namespace ForceTorqueUtility;

// DO NOT EDIT NEXT LINE
ForceTorqueUtilityRemoteStateOfferer::SubClassRegistry
    ForceTorqueUtilityRemoteStateOfferer::Registry(
        ForceTorqueUtilityRemoteStateOfferer::GetName(),
        &ForceTorqueUtilityRemoteStateOfferer::CreateInstance);

ForceTorqueUtilityRemoteStateOfferer::ForceTorqueUtilityRemoteStateOfferer(
    StatechartGroupXmlReaderPtr reader) :
    XMLRemoteStateOfferer<ForceTorqueUtilityStatechartContext>(reader)
{
}

void
ForceTorqueUtilityRemoteStateOfferer::onInitXMLRemoteStateOfferer()
{
}

void
ForceTorqueUtilityRemoteStateOfferer::onConnectXMLRemoteStateOfferer()
{
}

void
ForceTorqueUtilityRemoteStateOfferer::onExitXMLRemoteStateOfferer()
{
}

// DO NOT EDIT NEXT FUNCTION
std::string
ForceTorqueUtilityRemoteStateOfferer::GetName()
{
    return "ForceTorqueUtilityRemoteStateOfferer";
}

// DO NOT EDIT NEXT FUNCTION
XMLStateOffererFactoryBasePtr
ForceTorqueUtilityRemoteStateOfferer::CreateInstance(StatechartGroupXmlReaderPtr reader)
{
    return XMLStateOffererFactoryBasePtr(new ForceTorqueUtilityRemoteStateOfferer(reader));
}
