#pragma once

#include <ArmarXCore/statechart/xmlstates/XMLRemoteStateOfferer.h>

#include "ObjectMemoryGroupStatechartContext.generated.h"

namespace armarx::ObjectMemoryGroup
{
    class ObjectMemoryGroupRemoteStateOfferer :
        virtual public XMLRemoteStateOfferer<
            ObjectMemoryGroupStatechartContext> // Change this statechart context if you need another context (dont forget to change in the constructor as well)
    {
    public:
        ObjectMemoryGroupRemoteStateOfferer(StatechartGroupXmlReaderPtr reader);

        // inherited from RemoteStateOfferer
        void onInitXMLRemoteStateOfferer() override;
        void onConnectXMLRemoteStateOfferer() override;
        void onExitXMLRemoteStateOfferer() override;

        // static functions for AbstractFactory Method
        static std::string GetName();
        static XMLStateOffererFactoryBasePtr CreateInstance(StatechartGroupXmlReaderPtr reader);
        static SubClassRegistry Registry;
    };
} // namespace armarx::ObjectMemoryGroup
